local URNP_NoteTitle
local URNP_NoteText
local URNP_MainCat
local URNP_SubCat
local URNP_CurrentNote
local URNP_CurrPage
local URNotePadInitCount = 1
local URNP_Searching
local URNP_SearchMainCat
local URNP_SearchSubCat
local URNP_PinButton
local URNP_EditMain
local URNP_EditSub

-- ========================================================================================================
-- When Addon is loaded, check to see if the Database already exists, if not, load the default database.
-- ========================================================================================================
function URNotePad_Initialize() 

	if (URNotePadDB == nil) then
		URNotePadDB = {}
	end
	if (URNotePadDB.MainCategories == nil) then
		URNotePadDB.MainCategories = {}
		URNotePadDB.MainCategories = URNotePad_Default_MainCategories
		ChatFrame1:AddMessage("URNotePad Resetting Default Main Categories")
	end
	if (URNotePadDB.SubCategories == nil) then
		URNotePadDB.SubCategories = {}
		URNotePadDB.SubCategories = URNotePad_Default_SubCategories
		ChatFrame1:AddMessage("URNotePad Resetting Default Sub Categories")
	end

	if (URNotePadDB.Notes == nil) then
		URNotePadDB.Notes = {}
		URNotePadDB.Notes = URNotePad_Default_Notes
		ChatFrame1:AddMessage("URNotePad Resetting Default Notes")
	end
	if (URNotePadDB.Options == nil) then
		URNotePadDB.Options = {}
		URNotePadDB.Options = URNotePad_Default_Options
		ChatFrame1:AddMessage("URNotePad Resetting Default Options")
	end	
	URNP_PinButton = URNotePadDB.Options[1].URNPPinButton
end
	
-- ============================================================ UR Note Pad UI Button options.
function URNotePadButton_OnLoad(button)
	button:RegisterForDrag("LeftButton")

	-- ChatFrame1:AddMessage(button:GetName())

end

function URNotePadButton_OnClick(self, button)

	--ChatFrame1:AddMessage(URNotePadDB.Options[1].URNPPinButton)

	if button == "LeftButton" then
		if URNotePadFrame:IsShown() then
			URNotePadFrame:Hide()
		else
			URNPOptionsFrame:Hide()
			URNotePadFrame:Show()
		end
	end
	
	if button == "RightButton" then
		if URNPOptionsFrame:IsShown() then
			URNPOptionsFrame:Hide()
		else
			URNotePadFrame:Hide()
			URNPOptionsFramePinButton:SetChecked(URNP_PinButton)
			URNPOptionsFrame:Show()
			URNPOptionsFrameConfirmDelete:SetText(" ")
			URNPOptionsAddMain:SetText("Add")
			URNPOptionsDelMain:SetText("Del")
			URNPOptionsAddSub:SetText("Add")
			URNPOptionsDelSub:SetText("Del")
			URNPMainCatEdit:SetText("")
			URNPSubCatEdit:SetText("")
		end
	end
end

function URNotePadButton_OnDrag(self)
	if URNP_PinButton == 0 then
		self:StartMoving()
	end
end

-- ===================================================================== Main Frame On_Load & Close Button
function URNotePad_OnLoad(frame)
	frame:RegisterForDrag("LeftButton")
	frame:RegisterEvent("UNIT_COMBAT")

	frame.CloseButton = CreateFrame("Button","CloseButton",URNotePadFrame,"UIPanelCloseButton")
	frame.CloseButton:SetWidth(32)
	frame.CloseButton:SetHeight(32)
	frame.CloseButton:SetPoint("TOPRIGHT", -28, -9)
	frame.CloseButton:SetScript("OnClick", function ()
		frame:Hide()
		MainCatDropDown_Frame:Hide()
		SubCatDropDown_Frame:Hide()
	end)



	SlashCmdList["URNOTEPAD"] = URNotePad_Show
	SLASH_URNOTEPAD1 = "/urnp"
	SLASH_URNOTEPAD2 = "/urnotepad"

	frame:Hide()
end

function URNotePad_Show()
	URNotePadFrame:Show()
end

function URNotePad_OnEvent(frame, event, ...)

	if event == "ADDON_LOADED" then
		if URNotePadInitCount == 1 then
			ChatFrame1:AddMessage("URNotePad Data Loaded.")
			URNotePadInitCount = URNotePadInitCount + 1
		end
		URNotePad_Initialize()
		URNPSaveNoteButton:SetText("Search")
		URNPSaveNoteButton:Show()
	end
	
	if event == "UNIT_COMBAT" then
		if URNotePadFrame:IsShown() then
			URNotePadFrame:Hide()
			ChatFrame1:AddMessage("URNotePad Closed - You have Entered COMBAT!",1,0,0)
		end
	end

end

-- ============================================================ Note Text Entry Controls
function URNotePadFrameEditBox_OnSizeChanged(self)
	-- ChatFrame1:AddMessage("EDIT BOX RESIZE: " .. tostring(self:GetHeight()))

	if self:GetHeight() > 285 then
		self:SetHeight(285)
		self:SetText(URNP_NoteText)
	end
end

function URNotePadFrameEditBox_OnChar(self, text)
	-- ChatFrame1:AddMessage("OnChar"..text)

	if URNotePadFrameEditBox:GetHeight() <= 285 then
		URNP_NoteText = self:GetText()
	end
end

-- =============================================================== Create/Cancel/Done/Yes Note Button
function URNPCreateNoteButton_OnClick(self)
	
	if URNP_MainCat == "URNotePad Help" then
		URNPSaveNoteButton:Enable()
		URNPDeleteConfirmation:Hide()
	end

	-- ------------------------------------------------------- User Chose Yes, Delete the note.
	if URNPCreateNoteButton:GetText() == "YES" then
		URNPDeleteNoteButton_OnClick("YES","","")
	end

	-- -------------------------------------------------------If the Note is already shown then hide and put back up list
	if URNotePadFrameEditBox:IsShown() then
		URNotePadFrameTitleBox:Hide()
		URNotePadFrameEditBox:Hide()


		if URNP_Searching == 99 then
			URNPDeleteNoteButton:Hide()
			URNPSaveNoteButton:SetText("Search")
			URNPSaveNoteButton:Enable()
			URNPCreateNoteButton:Enable()
			URNPCreateNoteButton:SetText("Cancel Search")
			URNPDeleteConfirmation:Hide()
			URNotePadList:Show()
			
		else
			URNPCreateNoteButton:SetText("Create Note")
			URNPSaveNoteButton:SetText("Search")
			URNPSaveNoteButton:Show()
			URNPDeleteNoteButton:Hide()

			URNotePadList:Show()
			MainCatDropDown_Button:Enable()
			SubCatDropDown_Button:Enable()
		end

	elseif MainCatDropDown_Button:GetText() == "Category" and URNPCreateNoteButton:GetText() == "Create Note" then
	
		message("You must first select a Category and Sub Category to add the note in.")
	
	elseif	SubCatDropDown_Button:GetText() == "All" and URNPCreateNoteButton:GetText() == "Create Note" then
	
		message("You must first select a Category and Sub Category to add the note in.")
	
	elseif	MainCatDropDown_Button:GetText() == "URNotePad Help" then
		message("Sorry, but you can not create a note in URNotePad's Help Category.")

	else -- --------------------------------------------------This section runs for Create a New Note Only.

		if URNPCreateNoteButton:GetText() == "Cancel Search" then
			URNPCancelSearchButton_OnClick("URNPCancelSearchButton")
		else
			URNotePadList:Hide()
	
			URNotePadFrameTitleBox:SetText("Enter Note Title Here, then press TAB.")
			URNotePadFrameTitleBox:Show()
			URNotePadFrameEditBox:SetText("Enter your note here. To return to the Title, press TAB.")
			URNotePadFrameEditBox:Show()
			URNotePadFrameTitleBox:SetFocus()
			URNotePadFrameTitleBox:HighlightText(0, 38)

			URNPCreateNoteButton:SetText("Cancel Note")
			URNPSaveNoteButton:SetText("Save Note")
			URNPSaveNoteButton:Show()
			URNPDeleteNoteButton:Hide()
	
			MainCatDropDown_Button:Disable()
			SubCatDropDown_Button:Disable()
		end
	end
end

-- =============================================================== Save/Update/No/Search Note Button
function URNPSaveNoteButton_OnClick(self)

	-- ------------------------------------------------------- Update an existing Note
	if URNPSaveNoteButton:GetText() == "Update Note" then
		if #URNotePadFrameTitleBox:GetText() == 0 then
			message("You must enter a Note Title before you can save the note.")
			URNotePadFrameTitleBox:SetFocus()
		else
			URNotePadDB.Notes[URNP_CurrentNote].Title = URNotePadFrameTitleBox:GetText()
			URNotePadDB.Notes[URNP_CurrentNote].note = URNotePadFrameEditBox:GetText()
			ChatFrame1:AddMessage("Updated Note: "..URNP_CurrentNote)
			URNP_DisplayNotePage(URNP_CurrPage)
		end
	end

	-- ------------------------------------------------------- User Chose No, Not to Delete.
	if URNPSaveNoteButton:GetText() == "NO" then
		URNPDeleteNoteButton_OnClick("NO","","")
	end
	
	-- ------------------------------------------------------- Create a new Note
	if URNPSaveNoteButton:GetText() == "Save Note" then
		local URNPMaxTbl = #URNotePadDB.Notes
		URNPMaxTbl = URNPMaxTbl +1
		table.insert(URNotePadDB.Notes, URNPMaxTbl, { ["main"] = "x", ["subcat"] = "x", ["Title"] = "x", ["note"] = "x", })
		URNotePadDB.Notes[URNPMaxTbl].Title = URNotePadFrameTitleBox:GetText()
		URNotePadDB.Notes[URNPMaxTbl].note = URNotePadFrameEditBox:GetText()
		URNotePadDB.Notes[URNPMaxTbl].main = MainCatDropDown_Button:GetText()
		URNotePadDB.Notes[URNPMaxTbl].subcat = SubCatDropDown_Button:GetText()

		ChatFrame1:AddMessage("Note Added.")

		URNPSaveNoteButton:SetText("Update Note")
		URNPCreateNoteButton:SetText("Done")
		URNPDeleteNoteButton:Show()
		URNPDeleteNoteButton:Enable()
		URNP_CurrentNote = URNPMaxTbl

		URNP_DisplayNoteList(URNP_MainCat, URNP_SubCat)
		URNP_DisplayNotePage(URNP_CurrPage)
	end
	
	-- ------------------------------------------------------- Search for a Note
	if URNPSaveNoteButton:GetText() == "Search" then
		URNPSearchFrame:Show()
		URNotePadList:Hide()
		URNPSearchText:SetText("Enter the word or phrase to search for in the above area. You can enter a [SPACE] to show a list of all notes.\n\nThe Search will also search through the title.")
		URNotePadFrameTitleBox:Show()
		URNotePadFrameTitleBox:SetText("Enter Search Here.")
		URNotePadFrameTitleBox:HighlightText(0, 38)
		URNotePadFrameTitleBox:SetFocus()
		MainCatDropDown_Button:SetText("Searching")
		MainCatDropDown_Button:Disable()
		SubCatDropDown_Button:SetText("All")
		SubCatDropDown_Button:Disable()
		URNotePadFrameList:SetText("")
		URNPDeleteConfirmation:Hide()
		URNP_HideAllButtons()
	end
end

-- =============================================================== Cancel Note Search Button
function URNPCancelSearchButton_OnClick(self, button, down)
	URNPSearchFrame:Hide()
	URNotePadList:Show()
	URNotePadFrameTitleBox:Hide()
	MainCatDropDown_Button:SetText("Category")
	MainCatDropDown_Button:Enable()
	SubCatDropDown_Button:SetText("All")
	SubCatDropDown_Button:Disable()
	URNPDeleteConfirmation:Hide()
	URNPCreateNoteButton:SetText("Create Note")
	URNPCreateNoteButton:Enable()
	URNotePadFrameList:SetText("")
	URNPDeleteConfirmation:Hide()
	URNP_HideAllButtons()
	URNP_Searching = 0
end

-- =============================================================== Note Search Button
function URNPSearchButton_OnClick(self, button, down)

	URNP_SearchNotes(string.lower(URNotePadFrameTitleBox:GetText()))

end

-- =============================================================== Delete Note Button
function URNPDeleteNoteButton_OnClick(self, button, down)
	if self == "YES" then -- User chose YES to delete the note
		-- Delete Note
		table.remove(URNotePadDB.Notes, URNP_CurrentNote)
		
		URNPDeleteNoteButton:Enable()
		URNPSaveNoteButton:SetText("Update Note")
		URNPCreateNoteButton:SetText("Done")
		URNPDeleteConfirmation:Hide()		

		URNP_DisplayNoteList(URNP_MainCat, URNP_SubCat)
		URNP_DisplayNotePage(URNP_CurrPage)

		ChatFrame1:AddMessage("Deleted Note: "..URNP_CurrentNote)
	end
	if self == "NO" then -- User chose NO, Do NOT delete the note.
		-- Do not Delete Note
		URNPDeleteNoteButton:Enable()
		URNPSaveNoteButton:SetText("Update Note")
		URNPCreateNoteButton:SetText("Done")
		URNPDeleteConfirmation:Hide()
--		ChatFrame1:AddMessage("Delete Note Cancelled.")
	end
	if button == "LeftButton" then -- User Clicked the Delete button, disable it and reset Create New amd Save Buttons
		URNPDeleteNoteButton:Disable()
		URNPSaveNoteButton:SetText("NO")
		URNPCreateNoteButton:SetText("YES")
		URNPDeleteConfText:SetText("Are you sure you want to DELETE this note?")
		URNPDeleteConfirmation:Show()
--		ChatFrame1:AddMessage("Confirm Delete Note")
	end
end

-- =============================================================== Next Page Button
function URNP_NextPageButton_OnLoad(self)
	self:SetPoint("BOTTOM", -40, -10)
	self:Hide()
end

function URNP_NextPageButton_OnClick(self, button, down)
	if URNP_CurrPage < URNP_TotPages then
		URNP_CurrPage = URNP_CurrPage + 1
	end
	URNP_DisplayNotePage(URNP_CurrPage)
end

-- =============================================================== Previous Page Button
function URNP_PreviousPageButton_OnLoad(self)
	self:SetPoint("BOTTOM", -100, -10)
	self:Hide()
end

function URNP_PreviousPageButton_OnClick(self, button, down)
	if URNP_CurrPage > 1 then
		URNP_CurrPage = URNP_CurrPage - 1
	end
	URNP_DisplayNotePage(URNP_CurrPage)
end

-- ============================================================= Main Category DropDown Setup
function MainCatDropDown_Initialize()
	-- Will not be loaded yet for first run
	if URNotePadDB == nil then

	else
		table.sort(URNotePadDB.MainCategories, URNP_MainCatSort)

		for i=1, #URNotePadDB.MainCategories do
			info = {}
			level = 0

			local info =  URNotePadDB.MainCategories[i]
			level = info.level

			function info.func()
				MainCatDropDown_Button:SetText(tostring(info.text))
				URNP_MainCat = tostring(info.text)
--				ChatFrame1:AddMessage(MainCatDropDown_Button:GetText())
				if
					MainCatDropDown_Button:GetText() ~= "Category" then
					SubCatDropDown_Button:Enable()
					SubCatDropDown_Button:SetText("All")
					URNP_SubCat = "All"
					URNP_DisplayNoteList(URNP_MainCat, URNP_SubCat)
				end
			end
			UIDropDownMenu_AddButton(info, level)
		end

	end

end

function MainCatDropDown_OnLoad(self)
	UIDropDownMenu_Initialize(self, MainCatDropDown_Initialize);
end

function MainCatDropDown_OnClick(self, button, down)
	ToggleDropDownMenu(1, nil, MainCatDropDown_Frame, self:GetName(), 0, 0)
end

function MainCatDropDown_Button_Init(self)
	self:SetPoint("TOPLEFT", 70, -50)
end

function URNP_MainCatSort(a, b)
	if a.isTitle ~= 1 then
		return a.text < b.text
	end
end
-- ============================================================= Sub Category DropDown Setup
function SubCatDropDown_Initialize()
	-- Will not be loaded yet for first run
	if URNotePadDB == nil then

	else
		URNP_SubCatTable = {}
		URNP_SubCatTable = URNotePadDB.SubCategories
		table.sort(URNP_SubCatTable, URNP_SubCatSort)
		
		for i=1, #URNP_SubCatTable do
			info = {}
			level = 0

			local info =  URNP_SubCatTable[i]
			level = info.level
			
			if tostring(info.main) == MainCatDropDown_Button:GetText() then

				function info.func()
					SubCatDropDown_Button:SetText(tostring(info.text))
					URNP_SubCat = tostring(info.text)
--					ChatFrame1:AddMessage(SubCatDropDown_Button:GetText())
					URNP_DisplayNoteList(URNP_MainCat, URNP_SubCat)
				end
				UIDropDownMenu_AddButton(info, level)
			end
		end

	end

end

function SubCatDropDown_OnLoad(self)
	UIDropDownMenu_Initialize(self, SubCatDropDown_Initialize);
end

function SubCatDropDown_OnClick(self, button, down)
	ToggleDropDownMenu(1, nil, SubCatDropDown_Frame, self:GetName(), 0, 0)
end

function SubCatDropDown_Button_Init(self)
	self:SetPoint("TOPRIGHT", -45, -50)
	if MainCatDropDown_Button:GetText() == "Category" then
		SubCatDropDown_Button:Disable()
	end
end

function URNP_SubCatSort(a, b)
	if a.isTitle ~= 1 then
		return a.text < b.text
	end
end
-- =============================================================== Display Note List
function URNP_DisplayNoteList(mainCat, subCat)
	URNP_Notes_List = ""
	URNP_TotPages = 0
	URNP_TmpPages = 0
	URNP_Count = 0
	URNP_CurPage = 0

	-- message(mainCat .. "-" .. subCat .. " - " .. tostring( #URNotePadDB.Notes))
	-- URNotePadFrameList:SetText(mainCat .. "\n" .. subCat)

	URNP_NoteData = {}
	URNP_NoteData = URNotePadDB.Notes
	table.sort(URNP_NoteData, URNP_NotesListSort)

	URNPList = {}

	for i=1, #URNP_NoteData do
		info = {}
		
		info = URNP_NoteData[i]			
		if tostring(info.main) == mainCat then
			if tostring(info.subcat) == subCat then
				URNP_Count = URNP_Count + 1
				table.insert(URNPList, URNP_Count, i)
								
				--URNP_Notes_List = URNP_Notes_List .. tostring(info.Title) .. "\n"

			elseif subCat == "All" then
				URNP_Count = URNP_Count + 1
				table.insert(URNPList, URNP_Count, i)

				--URNP_Notes_List = URNP_Notes_List .. tostring(info.Title) .. "\n"
			end
		end
	end
	-- ----------------- Count Note Pages
	URNP_TmpPages = (URNP_Count / 15)
	URNP_TotPages = math.floor(URNP_TmpPages)
	if URNP_TmpPages > URNP_TotPages then
		URNP_TotPages = URNP_TotPages + 1
	end
	URNP_CurrPage=1
	URNP_DisplayNotePage(URNP_CurrPage)
end

function URNP_NotesListSort(a, b)
	if a.isTitle ~= 1 then
		return a.Title < b.Title
	end
end
-- =============================================================== Display Note Page
function URNP_DisplayNotePage(page)

	
	URNP_Notes_List = ""
	for p = 1, page do
	
		-- ----------------- Display Note Titles and select buttons

	    if p == page then
		for i=1, 15 do
			URNP_Rec = ((15*p)-15)+i
			
			if URNPList[URNP_Rec] ~= nil then
				local URNP_NoteTitle = ""
				local URNP_NoteNumber = 0
				URNP_NoteTitle = tostring(URNotePadDB.Notes[URNPList[URNP_Rec]].Title)
				if string.len(URNP_NoteTitle) > 27 then
					URNP_NoteTitle = string.sub(URNP_NoteTitle,1,27).."..."
				end

				URNP_NoteNumber = URNPList[URNP_Rec]

			--	ChatFrame1:AddMessage(URNP_NoteTitle)
				URNP_Notes_List = URNP_Notes_List .. URNP_NoteTitle .. "\n"

				if i == 1 then 
					URNotePadList.OpenNote1:SetScript("OnClick", function ()
						URNP_ShowNote(URNP_NoteNumber)
					end)
					URNotePadList.OpenNote1:Show() 
				end
				if i == 2 then 
					URNotePadList.OpenNote2:SetScript("OnClick", function ()
						URNP_ShowNote(URNP_NoteNumber)
					end)
					URNotePadList.OpenNote2:Show() 
				end
				if i == 3 then 
					URNotePadList.OpenNote3:SetScript("OnClick", function ()
						URNP_ShowNote(URNP_NoteNumber)
					end)
					URNotePadList.OpenNote3:Show() 
				end
				if i == 4 then 
					URNotePadList.OpenNote4:SetScript("OnClick", function ()
						URNP_ShowNote(URNP_NoteNumber)
					end)
					URNotePadList.OpenNote4:Show() 
				end
				if i == 5 then 
					URNotePadList.OpenNote5:SetScript("OnClick", function ()
						URNP_ShowNote(URNP_NoteNumber)
					end)
					URNotePadList.OpenNote5:Show() 
				end
				if i == 6 then 
					URNotePadList.OpenNote6:SetScript("OnClick", function ()
						URNP_ShowNote(URNP_NoteNumber)
					end)
					URNotePadList.OpenNote6:Show() 
				end
				if i == 7 then 
					URNotePadList.OpenNote7:SetScript("OnClick", function ()
						URNP_ShowNote(URNP_NoteNumber)
					end)
					URNotePadList.OpenNote7:Show() 
				end
				if i == 8 then 
					URNotePadList.OpenNote8:SetScript("OnClick", function ()
						URNP_ShowNote(URNP_NoteNumber)
					end)
					URNotePadList.OpenNote8:Show() 
				end
				if i == 9 then 
					URNotePadList.OpenNote9:SetScript("OnClick", function ()
						URNP_ShowNote(URNP_NoteNumber)
					end)
					URNotePadList.OpenNote9:Show() 
				end
				if i == 10 then 
					URNotePadList.OpenNote10:SetScript("OnClick", function ()
						URNP_ShowNote(URNP_NoteNumber)
					end)
					URNotePadList.OpenNote10:Show() 
				end
				if i == 11 then 
					URNotePadList.OpenNote11:SetScript("OnClick", function ()
						URNP_ShowNote(URNP_NoteNumber)
					end)
					URNotePadList.OpenNote11:Show() 
				end
				if i == 12 then 
					URNotePadList.OpenNote12:SetScript("OnClick", function ()
						URNP_ShowNote(URNP_NoteNumber)
					end)
					URNotePadList.OpenNote12:Show() 
				end
				if i == 13 then 
					URNotePadList.OpenNote13:SetScript("OnClick", function ()
						URNP_ShowNote(URNP_NoteNumber)
					end)
					URNotePadList.OpenNote13:Show() 
				end
				if i == 14 then 
					URNotePadList.OpenNote14:SetScript("OnClick", function ()
						URNP_ShowNote(URNP_NoteNumber)
					end)
					URNotePadList.OpenNote14:Show() 
				end
				if i == 15 then 
					URNotePadList.OpenNote15:SetScript("OnClick", function ()
						URNP_ShowNote(URNP_NoteNumber)
					end)
					URNotePadList.OpenNote15:Show() 
				end
			else
				if i == 1 then URNotePadList.OpenNote1:Hide() end
				if i == 2 then URNotePadList.OpenNote2:Hide() end
				if i == 3 then URNotePadList.OpenNote3:Hide() end
				if i == 4 then URNotePadList.OpenNote4:Hide() end
				if i == 5 then URNotePadList.OpenNote5:Hide() end
				if i == 6 then URNotePadList.OpenNote6:Hide() end
				if i == 7 then URNotePadList.OpenNote7:Hide() end
				if i == 8 then URNotePadList.OpenNote8:Hide() end
				if i == 9 then URNotePadList.OpenNote9:Hide() end
				if i == 10 then URNotePadList.OpenNote10:Hide() end
				if i == 11 then URNotePadList.OpenNote11:Hide() end
				if i == 12 then URNotePadList.OpenNote12:Hide() end
				if i == 13 then URNotePadList.OpenNote13:Hide() end
				if i == 14 then URNotePadList.OpenNote14:Hide() end
				if i == 15 then URNotePadList.OpenNote15:Hide() end
			end
			
		end
		
		URNotePadFrameList:SetText(URNP_Notes_List .. tostring(URNP_Count) .. " Total Notes. - " .. URNP_TotPages .. " Pages.")
	   end
	end

	URNP_NextPageButton:Hide()
	URNP_PreviousPageButton:Hide()

	if URNP_TotPages > 1 then
		URNP_NextPageButton:Show()
		URNP_PreviousPageButton:Show()

		if URNP_CurrPage == 1 then
			URNP_NextPageButton:Enable()
			URNP_PreviousPageButton:Disable()

		elseif URNP_CurrPage == URNP_TotPages then
			URNP_NextPageButton:Disable()
			URNP_PreviousPageButton:Enable()
	
		else
			URNP_NextPageButton:Enable()
			URNP_PreviousPageButton:Enable()
		end
	end



end

-- =============================================================== Show Note
function URNP_ShowNote(note)

	URNP_CurrentNote = note
	URNP_NoteText = URNotePadDB.Notes[note].note
	URNP_NoteTitle = URNotePadDB.Notes[note].Title
	URNP_SearchMainCat = URNotePadDB.Notes[note].main
	URNP_SearchSubCat = URNotePadDB.Notes[note].subcat

	URNotePadFrameEditBox:SetText(URNP_NoteText)
	URNotePadFrameTitleBox:SetText(URNP_NoteTitle)

	URNotePadList:Hide()

	URNotePadFrameTitleBox:Show()
	URNotePadFrameEditBox:Show()
	URNotePadFrameEditBox:SetFocus()
	URNPCreateNoteButton:SetText("Done")
	URNPCreateNoteButton:Enable()
	URNPCreateNoteButton:Show()
	URNPSaveNoteButton:SetText("Update Note")
	URNPSaveNoteButton:Show()
	URNPDeleteNoteButton:Show()
	URNPDeleteNoteButton:Enable()

	if URNP_Searching == 99 then 		-- Do this if displaying note for from a search
		URNPSaveNoteButton:Disable()
		URNPDeleteNoteButton:Disable()
		URNPDeleteConfText:SetText("Main: "..URNP_SearchMainCat.." - Sub: "..URNP_SearchSubCat)
		URNPDeleteConfirmation:Show()
		URNP_MainCat = "Searching"
	else					-- Do this for a regular note Display
-- Test Fix
		SubCatDropDown_Button:SetText(URNotePadDB.Notes[note].subcat)
		MainCatDropDown_Button:SetText(URNotePadDB.Notes[note].main)
		URNPSaveNoteButton:Enable()
		URNPDeleteNoteButton:Enable()
		URNP_SearchMainCat = ""
		URNP_SearchSubCat = ""
		URNPDeleteConfirmation:Hide()
	end

	if URNP_MainCat == "URNotePad Help" then
		URNPSaveNoteButton:Disable()
		URNPDeleteNoteButton:Disable()
		URNPDeleteConfText:SetText("Can not Update or Delete Help Data.")
		URNPDeleteConfirmation:Show()
	end

	MainCatDropDown_Button:Disable()
	SubCatDropDown_Button:Disable()

end

-- =============================================================== Search for Notes
function URNP_SearchNotes(URNP_SearchString)
	ChatFrame1:AddMessage("Searching for: "..URNP_SearchString)
	
	URNP_Notes_List = ""
	URNP_TotPages = 0
	URNP_TmpPages = 0
	URNP_Count = 0
	URNP_CurPage = 0
	URNP_Searching = 0

	URNPList = {}
	for i=1, #URNotePadDB.Notes do
		info = {}

		info = URNotePadDB.Notes[i]

		-- First Search the Note
		URNP_Searching = string.find(string.lower(tostring(info.note)),URNP_SearchString)

		-- If not found in note, Search the Notes Title
		if URNP_Searching == nil then 
			URNP_Searching = string.find(string.lower(tostring(info.Title)),URNP_SearchString)
			if URNP_Searching == nil then 
				URNP_Searching = 0 
			end
		end
		
		if URNP_Searching > 0 then
			URNP_Count = URNP_Count + 1
			table.insert(URNPList, URNP_Count, i)
		end
	end
	-- ----------------- Count Note Pages
	URNP_TmpPages = (URNP_Count / 15)
	URNP_TotPages = math.floor(URNP_TmpPages)
	if URNP_TmpPages > URNP_TotPages then
		URNP_TotPages = URNP_TotPages + 1
	end
	URNP_CurrPage=1

	if URNP_Count > 0 then
		URNP_Searching = 99 -- Random Value I chose for a flag
		URNPSearchFrame:Hide()		
		URNotePadList:Show()
		URNotePadFrameTitleBox:Hide()
		URNPSearchFrame:Hide()
		URNPDeleteConfirmation:Hide()
		URNPCreateNoteButton:Disable()



		URNP_DisplayNotePage(URNP_CurrPage)
	else
		URNPDeleteConfText:SetText("Search String not Found!!!!")
		URNPDeleteConfirmation:Show()
	end
end

-- ============================================================== Hide All Buttons
function URNP_HideAllButtons()
	URNotePadList.OpenNote1:Hide()
	URNotePadList.OpenNote2:Hide()
	URNotePadList.OpenNote3:Hide()
	URNotePadList.OpenNote4:Hide()
	URNotePadList.OpenNote5:Hide()
	URNotePadList.OpenNote6:Hide()
	URNotePadList.OpenNote7:Hide()
	URNotePadList.OpenNote8:Hide()
	URNotePadList.OpenNote9:Hide()
	URNotePadList.OpenNote10:Hide()
	URNotePadList.OpenNote11:Hide()
	URNotePadList.OpenNote12:Hide()
	URNotePadList.OpenNote13:Hide()
	URNotePadList.OpenNote14:Hide()
	URNotePadList.OpenNote15:Hide()
end

-- =======================================================================================================
-- =================================================================================== URNP OPTIONS SCREEN
-- =======================================================================================================

-- -------------------------------------------------------------- Pin Button
function URNPOptionsFramePinButton_OnLoad(self)
	URNPOptionsFramePinButton:SetChecked(URNP_PinButton)
end

function URNPOptionsFramePinButton_OnClick(self)
	if self:GetChecked() == nil then
		URNP_PinButton = 0
	else
		URNP_PinButton = 1
	end 
	URNotePadDB.Options[1].URNPPinButton = URNP_PinButton
end

-- -------------------------------------------------------------- Main Category Select
function URNPMainCatEdit_OnMouseWheel(self)

	URNPOptionsFrameConfirmDelete:SetText(" ")

	if MainCatDropDown_Button:GetText() == "Category" then
		URNPOptionsFrameConfirmDelete:SetText("Main Category not selected in URNotePad")
		PlaySound("INTERFACESOUND_GAMEMENUOPEN")
	else
		self:SetText(MainCatDropDown_Button:GetText())
	end
end

-- -------------------------------------------------------------- Add Main Category
function URNPOptionsAddMain_OnClick(self)

	if URNPOptionsAddMain:GetText() == "Add" then

		URNPOptionsFrameConfirmDelete:SetText(" ")
		
		local URNP_DupFound = 0
		local URNP_Error = 0

		URNP_EditMain = string.lower(URNPMainCatEdit:GetText())
	
		-- -------------------------- Check for Valid Name and Search for Main Category that already exists.

		if URNP_EditMain == ""  or string.sub(URNP_EditMain,1,1) == " " then
			URNPOptionsFrameConfirmDelete:SetText("ERROR! You must enter a vaid Main\nCategory name to add it.")
			PlaySound("INTERFACESOUND_GAMEMENUOPEN")
			URNP_Error = 1
		else
			for i=1, #URNotePadDB.MainCategories do

				if URNP_EditMain == string.lower(URNotePadDB.MainCategories[i].text) then
					URNP_DupFound = 1
					URNP_Error = 1
				end
			end
		end
	
		if URNP_DupFound == 1 then
			URNPOptionsFrameConfirmDelete:SetText("ERROR! The Main Category you tried to\nadd is already in the Database!")
			PlaySound("INTERFACESOUND_GAMEMENUOPEN")
		end

		-- ---------------------------- No Errors Found Add Main Category and Default All and Misc Sub-Categories
		if URNP_Error == 0 then

			URNP_EditMain = URNPMainCatEdit:GetText()
	
			local URNPMaxTbl = #URNotePadDB.MainCategories
			URNPMaxTbl = URNPMaxTbl +1
			table.insert(URNotePadDB.MainCategories, URNPMaxTbl, { ["level"] = 1, ["text"] = URNP_EditMain, })

			local URNPMaxTbl = #URNotePadDB.SubCategories
			URNPMaxTbl = URNPMaxTbl +1
			table.insert(URNotePadDB.SubCategories, URNPMaxTbl, { ["level"] = 1, ["text"] = "All", ["main"] = URNP_EditMain,})

			URNPMaxTbl = URNPMaxTbl +1
			table.insert(URNotePadDB.SubCategories, URNPMaxTbl, { ["level"] = 1, ["text"] = "Misc", ["main"] = URNP_EditMain,})

			URNPOptionsFrameConfirmDelete:SetText("Successfully created new Category. the \ndefault Misc Sub-Category also created.")
			PlaySound("INTERFACESOUND_GAMEMENUCLOSE")
		
			URNPMainCatEdit:SetText("")
		end
	else -- Called from Delete Main Verify
		URNPOptionsAddMain:SetText("Add")
		URNPOptionsDelMain:SetText("Del")
		URNPOptionsDelMain_OnClick("URNPOptionsDelMain")
	end
end

function URNPOptionsDelMainConfirm_OnClick(self)
	if URNPOptionsDelMain:GetText() == "No" then
		URNPOptionsFrameConfirmDelete:SetText("DELETE CANCELLED!")
		URNPOptionsAddMain:SetText("Add")
		URNPOptionsDelMain:SetText("Del")
	else
		URNPOptionsFrameConfirmDelete:SetText("Are you sure you want to DELETE\nthis category?")
		URNPOptionsAddMain:SetText("Yes")
		URNPOptionsDelMain:SetText("No")
	end
end
-- ------------------------------------------------------------ Delete Main Category
function URNPOptionsDelMain_OnClick(self)
    URNPOptionsFrameConfirmDelete:SetText(" ")

    local URNP_CatFound = 0
    local URNP_Error = 0
    local URNP_NotesFound = 0
    local URNP_DeleteSub = 0
    local URNP_TotalSubs = 0
	
    URNP_EditMain = string.lower(URNPMainCatEdit:GetText())
    
    if URNP_EditMain ~= "urnotepad help" then

	-- -------------------------- Check for Valid Name and Search for Main Category

	if URNP_EditMain == ""  or string.sub(URNP_EditMain,1,1) == " " then
		URNPOptionsFrameConfirmDelete:SetText("ERROR! You must enter a vaid Main\nCategory name to Delete it.")
		PlaySound("INTERFACESOUND_GAMEMENUOPEN")
		URNP_Error = 1
	else
		URNP_CatFound = 0
		for i=1, #URNotePadDB.MainCategories do

			if URNP_EditMain == string.lower(URNotePadDB.MainCategories[i].text) then
				URNP_CatFound = i
			end
		end

		if URNP_CatFound == 0 then
			URNPOptionsFrameConfirmDelete:SetText("ERROR! The Main Category you tried to\nDelete was not found!")
			PlaySound("INTERFACESOUND_GAMEMENUOPEN")
		end
	end

	-- ------------------------- Check for notes in the Main Category

	if URNP_CatFound > 0 and URNP_Error == 0 then
		for i=1, #URNotePadDB.Notes do
			
			if URNP_EditMain == string.lower(URNotePadDB.Notes[i].main) then
				URNP_NotesFound = 1
			end
		end
		

		if URNP_NotesFound == 1 then
			URNPOptionsFrameConfirmDelete:SetText("ERROR! Notes were found in the\nCategory to Delete! Can not Delete!")
			PlaySound("INTERFACESOUND_GAMEMENUOPEN")
		end
	end	

	-- ------------------------ Delete Sub Categories
	
--	ChatFrame1:AddMessage(URNP_CatFound.."-"..URNP_Error.."-"..URNP_NotesFound)

	if URNP_CatFound > 0 and URNP_Error == 0  and URNP_NotesFound == 0 then
		URNP_TotalSubs = #URNotePadDB.SubCategories

--		ChatFrame1:AddMessage("Conditions Met - "..#URNotePadDB.SubCategories)

		i = 2 ------------------------------------------------- Start on Second record - The first is the Header
		-- ---------------------------------------------------- Must use While statement cause table auto Re-indexes.
		while i <= #URNotePadDB.SubCategories do

			if URNotePadDB.SubCategories[i].main ~= nil then

--				ChatFrame1:AddMessage(URNP_EditMain .. "=" .. string.lower(URNotePadDB.SubCategories[i].main).." - "..i)
	
				if URNP_EditMain == string.lower(URNotePadDB.SubCategories[i].main) then
					table.remove(URNotePadDB.SubCategories, i)
					URNP_DeleteSub = 1
				else
					i = i + 1
				end
			else
				i = i + 1
			end
		end
				
		if URNP_DeleteSub == 1 then 
			URNPOptionsFrameConfirmDelete:SetText("Sub-Categories successfully removed!\n")
		end
	end

	-- ------------------------ Delete Main Category

	if URNP_CatFound > 0 and URNP_Error == 0  and URNP_NotesFound == 0 then
		
		table.remove(URNotePadDB.MainCategories, URNP_CatFound)
			
		if URNP_DeleteSub == 1 then 
			URNPOptionsFrameConfirmDelete:SetText(URNPOptionsFrameConfirmDelete:GetText().."Main-Category successfully removed!")
		else
			URNPOptionsFrameConfirmDelete:SetText("Main-Category successfully removed!")
		end
		
		URNPMainCatEdit:SetText("")
		MainCatDropDown_Button:SetText("Category")
		MainCatDropDown_Button:Enable()
		SubCatDropDown_Button:SetText("All")
		SubCatDropDown_Button:Disable()
		PlaySound("INTERFACESOUND_GAMEMENUCLOSE")
	end
    else
	URNPOptionsFrameConfirmDelete:SetText("ERROR! You can not delete the\nURNotePad Help Category!")
	PlaySound("INTERFACESOUND_GAMEMENUOPEN")
    end
end

-- -------------------------------------------------------------- Sub Category Select
function URNPSubCatEdit_OnMouseWheel(self)

	URNPOptionsFrameConfirmDelete:SetText(" ")

	if SubCatDropDown_Button:GetText() == "All" or SubCatDropDown_Button:GetText() == "SubCat" then
		URNPOptionsFrameConfirmDelete:SetText("Sub Category not selected in URNotePad")
		PlaySound("INTERFACESOUND_GAMEMENUOPEN")
	else
		self:SetText(SubCatDropDown_Button:GetText())
	end
end

-- -------------------------------------------------------------- Add Sub Category
function URNPOptionsAddSub_OnClick(self)

	if URNPOptionsAddSub:GetText() == "Add" then

		URNPOptionsFrameConfirmDelete:SetText(" ")
	
		local URNP_DupFound = 0
		local URNP_MainFound = 0
		local URNP_Error = 0

		URNP_EditSub = string.lower(URNPSubCatEdit:GetText())
		URNP_EditMain = string.lower(URNPMainCatEdit:GetText())

		-- -------------------------- Check for valid Main Cat name and search for Main Category to make sure it exists.
	
		if URNP_EditMain == ""  or string.sub(URNP_EditMain,1,1) == " " then
			URNPOptionsFrameConfirmDelete:SetText("ERROR! You must enter a vaid Main\nCategory to add a Sub.")
			PlaySound("INTERFACESOUND_GAMEMENUOPEN")
			URNP_Error = 1
		elseif URNP_EditMain == "urnotepad help" then
			URNPOptionsFrameConfirmDelete:SetText("ERROR! You can not create a sub Category\nin the URNotePad Help category.")
			PlaySound("INTERFACESOUND_GAMEMENUOPEN")
			URNP_Error = 1
		else
			for i=1, #URNotePadDB.MainCategories do

				if URNP_EditMain == string.lower(URNotePadDB.MainCategories[i].text) then
					URNP_MainFound = 1
				end
			end

			if URNP_MainFound == 0 then
				URNPOptionsFrameConfirmDelete:SetText("ERROR! Main Cetegory to add sub in\nwas not found!.")
				PlaySound("INTERFACESOUND_GAMEMENUOPEN")
			end
		end


		-- -------------------------- Check for Valid Name and Search for Sub Category in case it already exists.

		if URNP_EditSub == ""  or string.sub(URNP_EditSub,1,1) == " " then
			URNPOptionsFrameConfirmDelete:SetText("ERROR! You must enter a vaid Sub\nCategory name to add it.")
			PlaySound("INTERFACESOUND_GAMEMENUOPEN")
			URNP_Error = 1
		elseif URNP_MainFound == 1 then
		
			for i=1, #URNotePadDB.SubCategories do

				if URNP_EditSub == string.lower(URNotePadDB.SubCategories[i].text) then
					URNP_DupFound = 1
					URNP_Error = 1
				end
			end
		end
	
		if URNP_DupFound == 1 then
			URNPOptionsFrameConfirmDelete:SetText("ERROR! The Sub Category you tried to\nadd is already in the Database!")
			PlaySound("INTERFACESOUND_GAMEMENUOPEN")
		end

		-- ---------------------------- No Errors Found Add Main Category and Default All and Misc Sub-Categories
		if URNP_Error == 0 and URNP_MainFound == 1 then

			URNP_EditMain = URNPMainCatEdit:GetText()
			URNP_EditSub = URNPSubCatEdit:GetText()

			local URNPMaxTbl = #URNotePadDB.SubCategories
			URNPMaxTbl = URNPMaxTbl +1
			table.insert(URNotePadDB.SubCategories, URNPMaxTbl, { ["level"] = 1, ["main"] = URNP_EditMain, ["text"] = URNP_EditSub, })

			URNPOptionsFrameConfirmDelete:SetText("Successfully created new Sub-Category.")
			PlaySound("INTERFACESOUND_GAMEMENUCLOSE")
		
			URNPSubCatEdit:SetText("")
			URNPMainCatEdit:SetText("")
		end

	else -- Called from Delete Sub Verify
		URNPOptionsAddSub:SetText("Add")
		URNPOptionsDelSub:SetText("Del")
		URNPOptionsDelSub_OnClick("URNPOptionsDelSub")
	end	
end

function URNPOptionsDelSubConfirm_OnClick(self)
	if URNPOptionsDelSub:GetText() == "No" then
		URNPOptionsFrameConfirmDelete:SetText("DELETE CANCELLED!")
		URNPOptionsAddSub:SetText("Add")
		URNPOptionsDelSub:SetText("Del")
	else
		URNPOptionsFrameConfirmDelete:SetText("Are you sure you want to DELETE\nthis sub-category?")
		URNPOptionsAddSub:SetText("Yes")
		URNPOptionsDelSub:SetText("No")
	end
end

-- ------------------------------------------------------------ Delete Sub Category
function URNPOptionsDelSub_OnClick(self)
	URNPOptionsFrameConfirmDelete:SetText(" ")

	local URNP_SubFound = 0
	local URNP_Error = 0
	local URNP_NotesFound = 0
	local URNP_DeleteSub = 0
	local URNP_TotalSubs = 0
	
	URNP_EditMain = string.lower(URNPMainCatEdit:GetText())
    
    	if URNP_EditMain ~= "urnotepad help" then

		URNPOptionsFrameConfirmDelete:SetText(" ")
	
		local URNP_SubFound = 0
		local URNP_MainFound = 0
		local URNP_Error = 0

		URNP_EditSub = string.lower(URNPSubCatEdit:GetText())
		URNP_EditMain = string.lower(URNPMainCatEdit:GetText())

		-- -------------------------- Check for valid Main Cat name and search for Main Category to make sure it exists.
	
		if URNP_EditMain == ""  or string.sub(URNP_EditMain,1,1) == " " then
			URNPOptionsFrameConfirmDelete:SetText("ERROR! You must enter a vaid Main\nCategory to Del a Sub.")
			PlaySound("INTERFACESOUND_GAMEMENUOPEN")
			URNP_Error = 1
		else
			for i=1, #URNotePadDB.MainCategories do

				if URNP_EditMain == string.lower(URNotePadDB.MainCategories[i].text) then
					URNP_MainFound = 1
				end
			end

			if URNP_MainFound == 0 then
				URNPOptionsFrameConfirmDelete:SetText("ERROR! Main Cetegory to Del sub in\nwas not found!.")
				PlaySound("INTERFACESOUND_GAMEMENUOPEN")
			else
				URNPOptionsFrameConfirmDelete:SetText("Main Cetegory to Del sub in\nwas found!.")
				PlaySound("INTERFACESOUND_GAMEMENUCLOSE")
			end
		end

		-- -------------------------- Check for Valid Name and Search for Sub Category to Delete it.

		if URNP_EditSub == ""  or string.sub(URNP_EditSub,1,1) == " " then

			URNPOptionsFrameConfirmDelete:SetText("ERROR! You must enter a vaid Sub\nCategory name to add it.")
			PlaySound("INTERFACESOUND_GAMEMENUOPEN")
			URNP_Error = 1

		elseif URNP_MainFound == 1 then
		
			for i=1, #URNotePadDB.SubCategories do

				if URNP_EditSub == string.lower(URNotePadDB.SubCategories[i].text) then
					if URNP_EditMain == string.lower(URNotePadDB.SubCategories[i].main) then
						URNP_SubFound = i
					end
				end
			end
		end
	
		-- ------------------------- Check for notes in the Main Category

		if URNP_SubFound > 0 and URNP_Error == 0 then
			for i=1, #URNotePadDB.Notes do
				if URNP_EditSub == string.lower(URNotePadDB.Notes[i].subcat) then
					if URNP_EditMain == string.lower(URNotePadDB.Notes[i].main) then
						URNP_NotesFound = 1
					end 
				end
			end

			if URNP_NotesFound == 1 then
				URNPOptionsFrameConfirmDelete:SetText("ERROR! Notes were found in the sub-\nCategory to Delete! Can not Delete!")
				PlaySound("INTERFACESOUND_GAMEMENUOPEN")
			end
		end	


		-- -------------------------- Check if all Good and if so Delete!
		if URNP_SubFound > 0 and URNP_NotesFound == 0 and URNP_Error == 0 then
			table.remove(URNotePadDB.SubCategories, URNP_SubFound)
			URNPSubCatEdit:SetText("")
			
			URNPOptionsFrameConfirmDelete:SetText("Sub-Category Successfully Deleted!")
			MainCatDropDown_Button:SetText("Category")
			MainCatDropDown_Button:Enable()
			SubCatDropDown_Button:SetText("All")
			SubCatDropDown_Button:Disable()
			PlaySound("INTERFACESOUND_GAMEMENUCLOSE")
		elseif URNP_Error == 0 and URNP_NotesFound == 0 then
			URNPOptionsFrameConfirmDelete:SetText("ERROR! The Sub Category you tried to\nDelete is not in the Database!")
			PlaySound("INTERFACESOUND_GAMEMENUOPEN")
		end



	else
		URNPOptionsFrameConfirmDelete:SetText("ERROR! You can not delete the\nURNotePad Help Sub-Categories!")
		PlaySound("INTERFACESOUND_GAMEMENUOPEN")
	end
end

-- =================================================================================== Reset Default Categories.
function URNP_ResetDefaultCategories()	
	URNPOptionsFrameConfirmDelete:SetText("")
	if string.lower(URNPMainCatEdit:GetText()) == "reset" and string.lower(URNPSubCatEdit:GetText()) == "reset" then
		URNPOptionsFrameConfirmDelete:SetText("RESETTING")
		
		URNP_CatFound = 0		
		URNP_SubFound = 0
		URNP_NoteFound = 0
		local URNP_UpdateCount = 0

		local URNP_DefaultSubCat = {}
		URNP_DefaultSubCat = URNotePad_Default_SubCategories

		local URNP_DefaultNotes = {}
		URNP_DefaultNotes = URNotePad_Default_Notes

		-- -------------------------------------------- Check through Main Categories
		for j=1, #URNotePad_Default_MainCategories do
			URNP_CatFound = 0
			for i=1, #URNotePadDB.MainCategories do	
				if string.lower(URNotePad_Default_MainCategories[j].text) == string.lower(URNotePadDB.MainCategories[i].text) then
					URNP_CatFound = 1
				end 
			end
			if URNP_CatFound == 0 then -- Category not found.... Adding it.
				URNPMaxTbl = #URNotePadDB.MainCategories
				URNPMaxTbl = URNPMaxTbl + 1
				table.insert(URNotePadDB.MainCategories, URNPMaxTbl, { ["level"] = 1, ["text"] = URNotePad_Default_MainCategories[j].text, })
				URNP_UpdateCount = URNP_UpdateCount + 1
			end
		end

		-- -------------------------------------------- Check through Sub Categories		
		for j=1, #URNotePad_Default_SubCategories do
			URNP_SubFound = 0
			for i=1, #URNotePadDB.SubCategories do	
				if string.lower(URNotePad_Default_SubCategories[j].text) == string.lower(URNotePadDB.SubCategories[i].text) then
					if string.lower(URNotePad_Default_SubCategories[j].main) == string.lower(URNotePadDB.SubCategories[i].main) then
						URNP_SubFound = 1
					end
				end 
			end
			if URNP_SubFound == 0 then -- Sub-Category not found.... Adding it.
				URNPMaxTbl = #URNotePadDB.SubCategories
				URNPMaxTbl = URNPMaxTbl + 1
				table.insert(URNotePadDB.SubCategories, URNPMaxTbl, { ["level"] = 1, ["text"] = URNotePad_Default_SubCategories[j].text, ["main"] = URNotePad_Default_SubCategories[j].main, })
				URNP_UpdateCount = URNP_UpdateCount + 1
			end
		end

		-- -------------------------------------------- Check through Help Notes		
		for j=1, #URNotePad_Default_Notes do
			URNP_NoteFound = 0
			for i=1, #URNotePadDB.Notes do	
				if string.lower(URNotePad_Default_Notes[j].main) == string.lower(URNotePadDB.Notes[i].main) then
					if string.lower(URNotePad_Default_Notes[j].subcat) == string.lower(URNotePadDB.Notes[i].subcat) then
						if string.lower(URNotePad_Default_Notes[j].Title) == string.lower(URNotePadDB.Notes[i].Title) then
							URNP_NoteFound = 1
						end
					end
				end 
			end
			if URNP_NoteFound == 0 then -- Note not found.... Adding it.
				URNPMaxTbl = #URNotePadDB.Notes
				URNPMaxTbl = URNPMaxTbl + 1
				table.insert(URNotePadDB.Notes, URNPMaxTbl, { ["main"] = URNotePad_Default_Notes[j].main, ["subcat"] = URNotePad_Default_Notes[j].subcat, ["Title"] = URNotePad_Default_Notes[j].Title, ["note"] = URNotePad_Default_Notes[j].note, })
				URNP_UpdateCount = URNP_UpdateCount + 1
			end
		end

		if URNP_UpdateCount > 0 then
			URNPOptionsFrameConfirmDelete:SetText(URNP_UpdateCount.."-Default URNotePad Item(s) Restored!")
			PlaySound("INTERFACESOUND_GAMEMENUCLOSE")
		else
			URNPOptionsFrameConfirmDelete:SetText("No Items Restored, all is well!")
			PlaySound("INTERFACESOUND_GAMEMENUCLOSE")
		end

	else
		URNPOptionsFrameConfirmDelete:SetText("Confirm! Type reset in the Main/Sub boxes\nthen click the Reset Default button again!")
		PlaySound("INTERFACESOUND_GAMEMENUOPEN")
	end
end
